/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich / Dietmar Schrder
 Remarks:
 known Problems: none
 Version:        01.04.2009
 Description:    Webserver Applikation

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der
 GNU General Public License, wie von der Free Software Foundation verffentlicht,
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder
 (nach Ihrer Option) jeder spteren Version.

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung,
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE,
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License.

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 Programm erhalten haben.
 Falls nicht, schreiben Sie an die Free Software Foundation,
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
------------------------------------------------------------------------------*/
#include "httpd.h"
#include "webpage.h"
#include "zabex.h"
#include <stdio.h>
#include "memcheck.h"


struct http_table http_entry[MAX_TCP_ENTRY];

//Hier wird das codierte Passwort aus config.h gespeichert.
unsigned char http_auth_passwort[20];

unsigned char post_in[5] = {'O','U','T','='};
unsigned char post_ready[5] = {'S','U','B','='};
unsigned char PORT_tmp = 0;


//----------------------------------------------------------------------------
//Variablenarry zum einfgen in Webseite %VA@00 bis %VA@09
//unsigned int var_array[MAX_VAR_ARRAY] = {10,50,30,0,0,0,0,0,0,0};
//----------------------------------------------------------------------------

PROGMEM char http_header1[]={	"HTTP/1.0 200 Document follows\r\n"
                "Server: Zabex_Webserver\r\n"
                "Content-Type: text/html\r\n\r\n"};

PROGMEM char http_header2[]={	"HTTP/1.0 200 Document follows\r\n"
                "Server: Zabex_Webserver\r\n"
                "Content-Type: image/jpg\r\n\r\n"};

PROGMEM char http_header3[]={	"HTTP/1.0 401 Unauthorized\r\n"
                "Server: Zabex_Webserver\r\n"
                "WWW-Authenticate: Basic realm=\"NeedPassword\""
                "\r\nContent-Type: text/html\r\n\r\n"};

//----------------------------------------------------------------------------
//Kein Zugriff Seite bei keinem Passwort
PROGMEM char Page0[] = {"401 Unauthorized%END"};

unsigned char rx_header_end[5] = {"\r\n\r\n\0"};




#define U16 unsigned int

char * appendInt(char *p, U16 value){

  U16 x;
    x = value;
    if (value > 9999){
      *p++ = 48 + x / 10000;
      x%=10000;
    }
    if (value > 999){
      *p++ = 48 + x / 1000;
      x%=1000;
    }
    if (value > 99){
      *p++ = 48 + x / 100;
      x%=100;
    }
    if (value > 9){
      *p++ = 48 + x / 10;
      x%=10;
    }
    *p++ = 48 + x ;
    *p++ = ';';

    *p = 0;
    return p;
}


//----------------------------------------------------------------------------
//Initialisierung des Httpd Servers
void httpd_init (void)
{
  //HTTP_AUTH_STRING
  decode_base64((unsigned char*)HTTP_AUTH_STRING,http_auth_passwort);

  //Serverport und Anwendung eintragen
  add_tcp_app (HTTPD_PORT, (void(*)(unsigned char))httpd);
}

//----------------------------------------------------------------------------
//http Testserver
void httpd (unsigned char index)
{
  //Verbindung wurde abgebaut!
  if (tcp_entry[index].status & FIN_FLAG)
  {
      return;
  }


  //Allererste Aufruf des Ports fr diese Anwendung
  //HTTPD_Anwendungsstack lschen
  if(tcp_entry[index].app_status==1)
  {
    httpd_stack_clear(index);
  }

  //HTTP wurde bei dieser Verbindung zum ersten mal aufgerufen oder
  //HTML Header Retransmission!
  if (tcp_entry[index].app_status <= 2)
  {
    httpd_header_check (index);
    return;
  }

  //Der Header wurde gesendet und mit ACK besttigt (tcp_entry[index].app_status+1)
  //war das HTML Packet fertig, oder mssen weitere Daten gesendet werden, oder Retransmission?
  if (tcp_entry[index].app_status > 2 && tcp_entry[index].app_status < 0xFFFE)
  {
    httpd_data_send (index);
    return;
  }

  //Verbindung kann geschlossen werden! Alle HTML Daten wurden gesendet TCP Port kann
  //geschlossen werden (tcp_entry[index].app_status >= 0xFFFE)!!
  if (tcp_entry[index].app_status >= 0xFFFE)
  {
    tcp_entry[index].app_status = 0xFFFE;
    tcp_Port_close(index);
    return;
  }
  return;
}

//----------------------------------------------------------------------------
//HTTPD_STACK lschen
void httpd_stack_clear (unsigned char index){
  http_entry[index].http_header_type =0;
  http_entry[index].first_switch = 0;
  http_entry[index].http_auth = HTTP_AUTH_DEFAULT;
  http_entry[index].new_page_pointer = 0;
  http_entry[index].old_page_pointer = 0;
  http_entry[index].post = 0;
  http_entry[index].get = 0;
  http_entry[index].auth_ptr = http_auth_passwort;
  http_entry[index].post_ptr = post_in;
  http_entry[index].post_ready_ptr = post_ready;
  http_entry[index].hdr_end_pointer = rx_header_end;
  //HTTP_DEBUG("\r\n**** NEUE HTTP ANFORDERUNG ****\r\n\r\n");
  return;
}

//----------------------------------------------------------------------------
//Eintreffenden Header vom Client checken
void httpd_header_check (unsigned char index){
  unsigned int a = 0;
  unsigned int Fragezeichenpos;
  if(strcasestr_P((char*)&eth_buffer[TCP_DATA_START_VAR],PSTR("POST"))!=0)
    {
    http_entry[index].post = 1;
    }
  if(strcasestr_P((char*)&eth_buffer[TCP_DATA_START_VAR],PSTR("GET"))!=0)
    {
    http_entry[index].get = 1;
    }

  //finden der Authorization und das Ende im Header auch ber mehrere Packete hinweg!!
  if(*http_entry[index].hdr_end_pointer != 0)
  {
    for(a=TCP_DATA_START_VAR;a<(TCP_DATA_END_VAR);a++)
    {
      //HTTP_DEBUG("%c",eth_buffer[a]);

      if(!http_entry[index].http_auth)
      {
        if (eth_buffer[a] != *http_entry[index].auth_ptr++)
        {
          http_entry[index].auth_ptr = http_auth_passwort;
        }
        if(*http_entry[index].auth_ptr == 0)
        {
          http_entry[index].http_auth = 1;
          HTTP_DEBUG("  <---LOGIN OK!--->\r\n");
        }
      }

      if (eth_buffer[a] != *http_entry[index].hdr_end_pointer++)
      {
        http_entry[index].hdr_end_pointer = rx_header_end;
      }

      //Das Headerende wird mit (CR+LF+CR+LF) angezeigt!
      if(*http_entry[index].hdr_end_pointer == 0)
      {
        //HTTP_DEBUG("<---HEADER ENDE ERREICHT!--->\r\n");
        break;
      }
    }
  }
  
  //Angeforderte Seite steht in  eth_buffer[TCP_DATA_START_VAR...TCP_DATA_END_VAR]
  

  //Einzelne Postpacket (z.B. bei firefox)
  if(http_entry[index].http_auth && http_entry[index].post == 1)
  {
    for(a = TCP_DATA_START_VAR;a<(TCP_DATA_END_VAR);a++)
    {
      //Schaltanweisung finden!
      if (eth_buffer[a] != *http_entry[index].post_ptr++)
      {
        http_entry[index].post_ptr = post_in;
      }
      if(*http_entry[index].post_ptr == 0)
      {
        switch (eth_buffer[a+1])
          {
            case ('A'):
            PORT_tmp = PORT_tmp + 1;
              break;

            case ('B'):
            PORT_tmp = PORT_tmp + 2;
              break;

            case ('C'):
            PORT_tmp = PORT_tmp + 4;
              break;

            case ('D'):
            PORT_tmp = PORT_tmp + 8;
              break;
          }
        http_entry[index].post_ptr = post_in;
        //Schaltanweisung wurde gefunden
      }

      //Submit schliet die Suche ab!
      if (eth_buffer[a] != *http_entry[index].post_ready_ptr++)
      {
        http_entry[index].post_ready_ptr = post_ready;
      }
      if(*http_entry[index].post_ready_ptr == 0)
      {
        http_entry[index].post = 0;
//DSR:
        PORTC = PORT_tmp;
                PORT_tmp = 0;
        break;
        //Submit gefunden
      }
    }
  }

  //Welche datei wird angefordert? Wird diese in der Flashspeichertabelle gefunden?
  unsigned char page_index = 0;

  if (!http_entry[index].new_page_pointer)
  {
    //HTTP_DEBUG("\r\n<--REQUEST-->\r\n");
    Fragezeichenpos=0;
    for(a = TCP_DATA_START_VAR+5;a<(TCP_DATA_END_VAR);a++)
    {

//      HTTP_DEBUG("%c",eth_buffer[a]);

      if (eth_buffer[a] == '\r')
      {
        eth_buffer[a] = '\0';
        break;
      }else
      if ('?' == eth_buffer[a]) Fragezeichenpos=a;

    }
//    HTTP_DEBUG("\r\n");
    //HTTP_DEBUG("\r\n<--REQUEST ENDE-->\r\n");
    
    
    //Zugriff auf Parameter unabhngig vom Seitennamen
    //Parameter mssen wie folgta aufgebaut sein:
    //1. Einer von 10 Grobuchstaben ABCDEFGHIJ
    //2.= Zeichen
    //3, Ziffern bis zum Ende oder bis zum nchsten &
    //4. ggf. davon mehrere
   unsigned char GETindex;
   unsigned char ok=0;
   unsigned long value=0;
    //Parameter analysieren
    if (Fragezeichenpos){
        HTTP_DEBUG("Parameter\r\n");
        a = Fragezeichenpos+1;
        while (a<(TCP_DATA_END_VAR)){
            GETindex=(eth_buffer[a++] | 32)-97 ; //A =0 B=1...
            if (GETindex > 9)  break;

            if (eth_buffer[a++] != '=') break;
                
            value=0;
            while ((eth_buffer[a] != '&') &&  (eth_buffer[a] != ' ') && (eth_buffer[a] != 0)){
              value=10*value + eth_buffer[a++] -48;
            }
            GETwerte[GETindex] = value;
            
            if ('&'==eth_buffer[a]){
                a++;
              //HTTP_DEBUG("\r\nNext Param\r\n");
            }
            if (' '==eth_buffer[a]){
                ok=1;
                break;
            }   
            if (0==eth_buffer[a]){
                ok=1;
                break;
            }   
        }
        Basis.Zaehlerstand_Gas    = GETwerte[0];
        Basis.Zaehlerstand_Wasser = GETwerte[1];
        Basis.Zaehlerstand_Strom  = GETwerte[2];
    }   
    

    while(WEBPAGE_TABLE[page_index].filename)
    {
        if (strcasestr((char*)&eth_buffer[TCP_DATA_START_VAR],WEBPAGE_TABLE[page_index].filename)!=0)
        {
          http_entry[index].http_header_type = 0;
          //HTTP_DEBUG("\r\n\r\nDatei gefunden: ");
          //HTTP_DEBUG("%s",(char*)WEBPAGE_TABLE[page_index].filename);
          //HTTP_DEBUG("<----------------\r\n\r\n");
//HTML
          if (strcasestr(WEBPAGE_TABLE[page_index].filename,".htm")!=0)
          {
            http_entry[index].http_header_type = 0;
          }else
//Bilder
          if (strcasestr(WEBPAGE_TABLE[page_index].filename,".jpg")!=0)
          {
            http_entry[index].http_header_type = 1;
          }else
          if (strcasestr(WEBPAGE_TABLE[page_index].filename,".gif")!=0)
          {
            http_entry[index].http_header_type = 1;
          }else
//Aktionsseiten:
          if (strcasestr(WEBPAGE_TABLE[page_index].filename,".clr")!=0)
          {
            http_entry[index].http_header_type = 0;
            resetMinMax();
          }else
          if (strcasestr(WEBPAGE_TABLE[page_index].filename,".set")!=0)
          {
            http_entry[index].http_header_type = 0;
            schwellenSetzen();
          }

          http_entry[index].new_page_pointer = WEBPAGE_TABLE[page_index].page_pointer;
          break;
        }
        page_index++;
    }
  }

  //Wurde das Ende vom Header nicht erreicht
  //kommen noch weitere Stcke vom Header!
  if ((*http_entry[index].hdr_end_pointer != 0) || (http_entry[index].post == 1))
  {
    //Der Empfang wird Quitiert und es wird auf weiteres Headerstck gewartet
    tcp_entry[index].status =  ACK_FLAG;
    create_new_tcp_packet(0,index);
    //Warten auf weitere Headerpackete
    tcp_entry[index].app_status = 1;
    return;
  }

  //Wurde das Passwort in den ganzen Headerpacketen gefunden?
  //Wenn nicht dann ausfhren und Passwort anfordern!
  if((!http_entry[index].http_auth) && tcp_entry[index].status&PSH_FLAG)
  {
    //HTTP_AUTH_Header senden!
    http_entry[index].new_page_pointer = Page0;
    memcpy_P((char*)&eth_buffer[TCP_DATA_START_VAR],http_header3,(sizeof(http_header3)-1));
    tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
    create_new_tcp_packet((sizeof(http_header3)-1),index);
    tcp_entry[index].app_status = 2;
    return;
  }

  //Standard INDEX.HTM Seite wenn keine andere gefunden wurde
  if (!http_entry[index].new_page_pointer)
  {
    //Besucher Counter
    besucherCounter++;

    http_entry[index].new_page_pointer = PageIndex;//Defaultseite. War ursprnglich = Page1;
    http_entry[index].http_header_type = 0;
  }

  tcp_entry[index].app_status = 2;
  //Seiten Header wird gesendet
  if(http_entry[index].http_header_type == 1)
  {
    memcpy_P((char*)&eth_buffer[TCP_DATA_START_VAR],http_header2,(sizeof(http_header2)-1));
        tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
        create_new_tcp_packet((sizeof(http_header2)-1),index);
        return;
  }

  if(http_entry[index].http_header_type == 0)
  {
    memcpy_P((char*)&eth_buffer[TCP_DATA_START_VAR],http_header1,(sizeof(http_header1)-1));
        tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
        create_new_tcp_packet((sizeof(http_header1)-1),index);
        return;
  }
    return;
}

//----------------------------------------------------------------------------
//Daten Packete an Client schicken
void httpd_data_send (unsigned char index)
{
  unsigned int a;
  unsigned char str_len=0;
  unsigned char hh;
  unsigned char mm;
  unsigned char ss;

  char var_conversion_buffer[CONVERSION_BUFFER_LEN];

  //Passwort wurde im Header nicht gefunden
  if(!http_entry[index].http_auth)
  {
    http_entry[index].new_page_pointer = Page0;
  }

  //kein Packet empfangen Retransmission des alten Packetes
  if (tcp_entry[index].status == 0)
  {
    http_entry[index].new_page_pointer = http_entry[index].old_page_pointer;
  }
  http_entry[index].old_page_pointer = http_entry[index].new_page_pointer;

  for (a = 0;a<(MTU_SIZE-(TCP_DATA_START)-150);a++)
  {
    unsigned char b;
    b = pgm_read_byte(http_entry[index].new_page_pointer++);
    eth_buffer[TCP_DATA_START + a] = b;

    //Mssen Variablen ins Packet eingesetzt werden? ===> %VA@00 bis %VA@09
    if (b == '%')
    {
      if (strncasecmp_P("VA@",http_entry[index].new_page_pointer,3)==0)
      {
        b = (pgm_read_byte(http_entry[index].new_page_pointer+3)-48)*10;
        b +=(pgm_read_byte(http_entry[index].new_page_pointer+4)-48);
        itoa (adc_array[b],var_conversion_buffer,10);
        str_len = strnlen(var_conversion_buffer,CONVERSION_BUFFER_LEN);
        memmove(&eth_buffer[TCP_DATA_START+a],var_conversion_buffer,str_len);
        a += (str_len-1);
        http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+5;
      }
//Dietmar:	Zeit einbauen mit %TI
      if (strncasecmp_P("TI",http_entry[index].new_page_pointer,2)==0) //Time Information
      {

        hh = ((time/3600))%24;//GMT+1
        mm = (time/60)%60;
        ss = time %60;
        sprintf(var_conversion_buffer, "%2i:%02i:%02i",hh,mm,ss);
        str_len = strnlen(var_conversion_buffer,CONVERSION_BUFFER_LEN);
        memmove(&eth_buffer[TCP_DATA_START+a],var_conversion_buffer,str_len);
        a +=  (str_len-1);
        http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+2;
      }

//Min+Maxwerte
      if (strncasecmp_P("MX",http_entry[index].new_page_pointer,2)==0)
      {
        b = (pgm_read_byte(http_entry[index].new_page_pointer+2)-48);
        switch (b){
          case 1: itoa (pegelMinGas,var_conversion_buffer,10); break;
          case 2: itoa (pegelMaxGas,var_conversion_buffer,10); break;
          case 3: itoa (pegelMinWasser,var_conversion_buffer,10); break;
          case 4: itoa (pegelMaxWasser,var_conversion_buffer,10); break;
          case 5: itoa (pegelMinStrom,var_conversion_buffer,10); break;
          case 6: itoa (pegelMaxStrom,var_conversion_buffer,10); break;
          case 7: ltoa ((strom_dauer)/61L,var_conversion_buffer,10); break; //in Sekunden
          case 8: itoa (sekundenSeitStromflanke,var_conversion_buffer,10); break;
          case 9: ltoa (besucherCounter,var_conversion_buffer,10); break;
  
          default:
             sprintf(var_conversion_buffer,"? MX%d",b);
        }

        str_len = strnlen(var_conversion_buffer,CONVERSION_BUFFER_LEN);
        memmove(&eth_buffer[TCP_DATA_START+a],var_conversion_buffer,str_len);
        a += (str_len-1);
        http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+3;
      }

      if (strncasecmp_P("LH",http_entry[index].new_page_pointer,2)==0)
      {
        b = (pgm_read_byte(http_entry[index].new_page_pointer+2)-48);
        switch (b){
          case 1: itoa (gas_l,var_conversion_buffer,10); break;
          case 2: itoa (gas_h,var_conversion_buffer,10); break;
          case 3: itoa (wasser_l,var_conversion_buffer,10); break;
          case 4: itoa (wasser_h,var_conversion_buffer,10); break;
          case 5: itoa (strom_l,var_conversion_buffer,10); break;
          case 6: itoa (strom_h,var_conversion_buffer,10); break;
          case 7: itoa (tageSeitEinschalten,var_conversion_buffer,10); break;
          case 8: itoa (tag,var_conversion_buffer,10); break;
          case 9: itoa ((time/3600)%24,var_conversion_buffer,10); break;  //Stunde des Tages

          default:
             sprintf(var_conversion_buffer,"? LH%d",b);
        }

        str_len = strnlen(var_conversion_buffer,CONVERSION_BUFFER_LEN);
        memmove(&eth_buffer[TCP_DATA_START+a],var_conversion_buffer,str_len);
        a += (str_len-1);
        http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+3; 
      }


//Zhlerstnde
      if (strncasecmp_P("ZS",http_entry[index].new_page_pointer,2)==0)
      {
        b = (pgm_read_byte(http_entry[index].new_page_pointer+2));
        if ('G'==b){ ltoa (jetzt.Zaehlerstand_Gas,var_conversion_buffer,10);}
        else
        if ('W'==b){ ltoa (jetzt.Zaehlerstand_Wasser,var_conversion_buffer,10);}
        else
        if ('S'==b){ ltoa (jetzt.Zaehlerstand_Strom,var_conversion_buffer,10);}
        else
        if ('R'==b){ itoa (watt_momentan,var_conversion_buffer,10);}
        else
        if ('M'==b){ itoa (get_mem_unused(),var_conversion_buffer,10);}
        else
        sprintf(var_conversion_buffer,"? ZS%c",b);

        str_len = strnlen(var_conversion_buffer,CONVERSION_BUFFER_LEN);
        memmove(&eth_buffer[TCP_DATA_START+a],var_conversion_buffer,str_len);
        a +=  (str_len-1);
        http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+3;
      }

     //GETwerte
      if (strncasecmp_P("NN",http_entry[index].new_page_pointer,2)==0)
      {
        for (int i=0; i<10; i++) {
          str_len = sprintf(var_conversion_buffer,"%lu;",GETwerte[i]);
          memmove(&eth_buffer[TCP_DATA_START+a],var_conversion_buffer,str_len);
          a +=str_len;
        }
        eth_buffer[TCP_DATA_START+a]=0;
        a--;
      
        http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+2;
      }
      
      
      //Verbrauchsverlauf
      if (strncasecmp_P("VL",http_entry[index].new_page_pointer,2)==0)
      {
        b = (pgm_read_byte(http_entry[index].new_page_pointer+2));
        for (int i=0; i<SPEICHERTIEFE_VERBRAUCH; i++) {
          str_len =0;
          if ('G'==b){
            str_len = sprintf(var_conversion_buffer,"%u;",verbrauch[i].Gas);
          }else  
          if ('W'==b){
            str_len = sprintf(var_conversion_buffer,"%u;",verbrauch[i].Wasser);
          }else  
          if ('S'==b){
            str_len = sprintf(var_conversion_buffer,"%u;",verbrauch[i].Strom);
          }else  
          if ('K'==b){
            str_len = sprintf(var_conversion_buffer,"%u;",verbrauch[i].kuerzesteUmlaufzeitStrom);//in Tics
          }else{
             str_len = sprintf(var_conversion_buffer,"VL??;");//in Tics 
          }

          if (str_len){
            memmove(&eth_buffer[TCP_DATA_START+a],var_conversion_buffer,str_len);
            a +=str_len;
          }
        }
        eth_buffer[TCP_DATA_START+a]=0;
        a--;
      
        http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+3;
      }

//Zaehlerstand Historie
     if (strncasecmp_P("HI",http_entry[index].new_page_pointer,2)==0)
     {
        b = (pgm_read_byte(http_entry[index].new_page_pointer+2));
        for (int i=0; i<SPEICHERTIEFE_TAGE; i++) {
          if ('G'==b){
            str_len = sprintf(var_conversion_buffer,"%ld;",ZaehlerstandTage[i].Zaehlerstand_Gas);
          }else  
          if ('W'==b){
            str_len = sprintf(var_conversion_buffer,"%ld;",ZaehlerstandTage[i].Zaehlerstand_Wasser);
          }else  
          if ('S'==b){
            str_len = sprintf(var_conversion_buffer,"%ld;",ZaehlerstandTage[i].Zaehlerstand_Strom);
          }
          
          memmove(&eth_buffer[TCP_DATA_START+a],var_conversion_buffer,str_len);
          a = a + (str_len);
        }
        eth_buffer[TCP_DATA_START+a]=0;
        a--;
      
        http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+3;
     }

//diverse Variablen und Messwerte
     if (strncasecmp_P("XX",http_entry[index].new_page_pointer,2)==0)
     {
       hh = ((time/3600))%24;//GMT+1
       mm = (time/60)%60;
       ss = time %60;
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;%2u:%02u:%02u;",time,hh,mm,ss); //Zeit in Sekunden seit 1900 (UTC) und als String
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",watt_momentan);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",tageSeitEinschalten);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",tag);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",viertelstunde);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",sekundenSeitStromflanke);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",strom_dauer);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",stromtic);
       
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",jetzt.Zaehlerstand_Gas);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",jetzt.Zaehlerstand_Wasser);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",jetzt.Zaehlerstand_Strom);

       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",Basis.Zaehlerstand_Gas);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",Basis.Zaehlerstand_Wasser);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",Basis.Zaehlerstand_Strom);

       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",ntp_timer); //Sekunden bis zum NTP-Refresh


       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",gas_h);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",gas_l);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",wasser_l);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",wasser_h);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",strom_l);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",strom_h);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",pegelMaxGas);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",pegelMinGas);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",pegelMaxWasser);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",pegelMinWasser);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",pegelMaxStrom);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",pegelMinStrom);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;%u;%u;",adc_array[0],adc_array[1],adc_array[2]);
       
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",besucherCounter);
       
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",SPEICHERTIEFE_TAGE);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",SPEICHERTIEFE_VERBRAUCH);
       a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%u;",get_mem_unused());
              
       for (int i=0; i<10; i++) {
         a+= sprintf((char *)&eth_buffer[TCP_DATA_START+a],"%lu;",GETwerte[i]);
       }
     
       eth_buffer[TCP_DATA_START+a]=0;
       a--;
       http_entry[index].new_page_pointer=http_entry[index].new_page_pointer+2;
     } 
     
      //wurde das Ende des Packetes erreicht?
      //Verbindung TCP Port kann beim nchsten ACK geschlossen werden
      //Schleife wird abgebrochen keine Daten mehr!!
      if (strncasecmp_P("END",http_entry[index].new_page_pointer,3)==0)
      {
        tcp_entry[index].app_status = 0xFFFD;
        break;
      }
    }
  }
  //Erzeugte Packet kann nun gesendet werden!
  tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
  create_new_tcp_packet(a,index);
  return;
}
