/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:
 known Problems: none
 Version:        24.10.2007
 Description:    Timer Routinen

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/
#include "timer.h"
#include "zabex.h"

volatile unsigned long time;
volatile unsigned long time_watchdog = 0;

//----------------------------------------------------------------------------
//Diese Routine startet und inizialisiert den Timer
void timer_init (void)
{
  TCCR1B |= (1<<WGM12) | (1<<CS10 | 0<<CS11 | 1<<CS12);
	TCNT1 = 0;
	OCR1A = (F_CPU / 1024) - 1;
	#if defined (__AVR_ATmega644__) || defined (__AVR_ATmega644P__)
  	TIMSK1 = (1 << OCIE1A);
  #else
  	TIMSK |= (1 << OCIE1A);
	#endif 

  
  //Timer0 fr die Stromverbrauchsmessung initialisieren. Erzeugt IRQs mit 20Hz
  #if defined (__AVR_ATmega644__) || defined (__AVR_ATmega644P__)
    TCCR0A =  0; 
    TCCR0B =  0b00000101; //Vorteiler 1024 -> gibt 15625 KHz Zhlfrequenz und 61,035Hz IRQ's
  #else    
    TCCR0 =  0b00000101; //Vorteiler 1024 -> gibt 15625 KHz Zhlfrequenz und 61,035Hz IRQ's
  #endif 
  #if defined (__AVR_ATmega644__) || defined (__AVR_ATmega644P__)
    TIMSK0 = 1<<TOIE0; //enable overflow INT 
  #else  
    TIMSK |= 1<<TOIE0; //enable overflow INT 
  #endif 
  
  
return;
};

//----------------------------------------------------------------------------
//Timer Interrupt
ISR (TIMER1_COMPA_vect){
  //Sekunde um 1 erhhen
  time++;
  sekundenSeitStromflanke++;

  if((time_watchdog++) > WTT)
      {
      time_watchdog = 0;
      stack_init();
      }
  eth.timer = 1;
  ntp_timer--;
      
  if (0==(time % 86400)){ //Mitternacht
    tageSeitEinschalten++;
    tag = tageSeitEinschalten % SPEICHERTIEFE_TAGE;
//    if (tageSeitEinschalten>=SPEICHERTIEFE_TAGE) tageSeitEinschalten=0;
    ZaehlerstandTage[tag].Zaehlerstand_Gas = jetzt.Zaehlerstand_Gas;
    ZaehlerstandTage[tag].Zaehlerstand_Wasser = jetzt.Zaehlerstand_Wasser;
    ZaehlerstandTage[tag].Zaehlerstand_Strom = jetzt.Zaehlerstand_Strom;
  }
  
  viertelstunde_neu = (time/900) % SPEICHERTIEFE_VERBRAUCH;
  if (viertelstunde != viertelstunde_neu){
    viertelstunde = viertelstunde_neu;
    verbrauch[viertelstunde].Gas=0;
    verbrauch[viertelstunde].Wasser=0;
    verbrauch[viertelstunde].Strom=0;
    verbrauch[viertelstunde].kuerzesteUmlaufzeitStrom = 65535;

  }  
}

ISR (TIMER0_OVF_vect){
    stromtic++;  
    if (1==strom_markierung){
        strom_dauer = stromtic;
        stromtic=0;
        strom_markierung=2;
        if ( verbrauch[viertelstunde].kuerzesteUmlaufzeitStrom > strom_dauer){
            verbrauch[viertelstunde].kuerzesteUmlaufzeitStrom = strom_dauer;
        }
    }
   ANALOG_ON;//nchste ADC-Messung starten
}

